(function ($, Drupal, drupalSettings) {
    'use strict';

    $("#display_tree").on ("click", function (e) {
        tree.options ({'branches' : 'straight'}, true);
    });
    $ ("[data-direction]").on ("click", function (e) {
        var which_function = $(this).data ("direction") == 'vertical' ? tree.spacing_x : tree.spacing_y;
        which_function (which_function () + (+ $(this).data ("amount"))).update();
    });
    $(".phylotree-layout-mode").on ("change", function (e) {
        if ($(this).is(':checked')) {
            if (tree.radial () != ($(this).data ("mode") == "radial")) {
                tree.radial (!tree.radial ()).placenodes().update ();
            }
        }
    });
    $("#toggle_animation").on ("click", function (e) {
        var current_mode = $(this).hasClass('active');
        $(this).toggleClass('active');
        tree.options ({'transitions' : !current_mode} );
    });
    $(".phylotree-align-toggler").on ("change", function (e) {
        if ($(this).is(':checked')) {
            if (tree.align_tips ($(this).data ("align") == "right")) {
                tree.placenodes().update ();
            }
        }
    });
    function sort_nodes (asc) {
        tree.traverse_and_compute (function (n) {
            var d = 1;
            if (n.children && n.children.length) {
                d += d3.max (n.children, function (d) { return d["count_depth"];});
            }
            n["count_depth"] = d;
        });
        tree.resort_children (function (a,b) {
            return (a["count_depth"] - b["count_depth"]) * (asc ? 1 : -1);
        });
    }
    $("#sort_original").on ("click", function (e) {
        tree.resort_children (function (a,b) {
            return a["original_child_order"] - b["original_child_order"];
        });
    });
    $("#sort_ascending").on ("click", function (e) {
        sort_nodes (true);
    });
    $("#sort_descending").on ("click", function (e) {
        sort_nodes (false);
    });

    var region_content = $(".region-content");

    var width  = region_content.width() - 50, height = 600;
    var tree = d3.layout.phylotree("body")
        .size([height, width]);
    var container_id = '#tree_container';
    var svg = d3.select(container_id).append("svg")
        .attr("width", width)
        .attr("height", height);

    // var svg_selector = $("svg");
    // var page_wrapper = $("#page-wrapper");
    // var sidebar_first = $("#sidebar-first");

    // var observer = new MutationObserver(function(mutations) {
    //     mutations.forEach(function(mutationRecord) {
    //         // console.log("resize");
    //         resize();
    //     });
    // });
    // var target = document.querySelector('svg');
    // observer.observe(target, { attributes : true, attributeFilter : ['width'] });
    //
    // function resize() {
    //     if (svg_selector.width() >= page_wrapper.width() - (page_wrapper.width() - region_content.width())) {
    //         var newWidth = svg_selector.width()*2;
    //         $("#page-wrapper").width(newWidth);
    //     }
    // }

    Drupal.behaviors.phylotree_viewer = {
        attach: function(context, settings) {
            once('myPhylotreeViewerBehavior', 'html').forEach(function () {
                var file_contents = drupalSettings.files.contents;
                tree(file_contents).svg (svg).layout();
                // if (svg_selector.width() > region_content.width() - 30) {
                //     tree.spacing_y (Math.floor((svg_selector.width() - region_content.width())/65)).update();
                // }
            });
        }
        // detach: function (context, settings, trigger) {
        //     // observer.disconnect();
        // }
    };
}(jQuery, Drupal, drupalSettings));